package com.ss.android.article.wenda.recommend

import android.graphics.Rect
import android.view.View
import android.view.ViewStub
import com.ss.android.article.base.R

/**
 * 推人卡片View代理
 *
 * @author zhanghao
 * @date 2018/4/27
 * @email zhanghao@bytedance.com
 */
class RecommendFollowDelegate(recommendStub: ViewStub) {

    var recommendStub: ViewStub? = recommendStub
    var recommendLayout: RecommendFollowLayout? = null
    var recommendContainer: View? = null

    private var mHasAdjustTrianglePos = false

    /**
     * 尝试初始化RecommendFollowLayout
     */
    fun tryInitRecommendLayout(anchor: View?) {
        if (recommendLayout != null || recommendStub?.parent == null) {
            return
        }
        recommendLayout = recommendStub?.inflate() as RecommendFollowLayout?
        recommendLayout?.visibility = View.GONE
        recommendContainer = recommendLayout?.findViewById(R.id.recommend_follow_container)
    }

    fun tryAdjustTrianglePos(anchor: View?) {
        anchor?.post {
            if (mHasAdjustTrianglePos) {
                return@post
            }
            val rect = Rect()
            anchor.getGlobalVisibleRect(rect)
            val centerPos = (rect.left + rect.right) / 2
            recommendLayout?.adjustTrianglePos(centerPos)
            mHasAdjustTrianglePos = true
        }
    }
}